<?php
/******************************************************************************/
//                               © lokanaft                                   //
/******************************************************************************/
if(!defined('VALID_CMS'))die('ACCESS DENIED');

class cpListTable{

    private $fields_sql = array();
    private $fields = array();
    private $actions = array();
    private $from   = '';
    private $where  = array();
    private $order  = '';
    private $limit  = '';
    private $perpage= 30;
    private $page   = 0;
    private $inDB;
    private $total  = 0;
    private $result;


    public function __construct(){
        $this->inDB = cmsDatabase::getInstance();
    }

    public function setFields($fields){
        foreach($fields as $field){
            if(isset($field['fdate'])){
                $this->fields_sql[] = $this->formatDateField($field);
            }else{
                $this->fields_sql[] = $field['field'].(isset($field['as']) ? " AS `{$field['as']}`" : '');
            }
            $this->fields[(isset($field['as']) ? $field['as'] : $field['field'])] = $field;
        }
        return $this;
    }
    
    public function setActions($actions){
        $this->actions = $actions;
        return $this;
    }
    
    public function setFrom($val){
        $pref = cmsConfig::getConfig('db_prefix');
        $this->from = ($pref !== 'cms' && strpos($val, 'cms') === 0) ? str_replace('cms_', $pref.'_', $val) : $val;
        return $this;
    }
    
    public function setWhere($val = ''){
        if($val)$this->where[] = $val;
        return $this;
    }
    
    public function setPerpage($val = 0){
        $this->perpage = (is_numeric($val) && $val > 0) ? $val : $this->perpage;
        return $this;
    }
    
    public function setOrder($by = '', $so = 'asc'){
        if($so !== 'asc')$so = 'desc';
        if($by)$this->order = $by.' '.$so;
        return $this;
    }
    
    public function setLimit($val = ''){
        if($val)$this->limit = $val;
        return $this;
    }
    
    public function setPage($val = 0){
        if($val)$this->page = $val;
        return $this;
    }
    
    private function calcLimit(){
        $this->limit = (($this->page-1)*$this->perpage).', '.$this->perpage;
        return $this;
    }
    
    private function formatDateField($field){
        return "DATE_FORMAT(`{$field['field']}`, '{$field['fdate']}')".' AS `'.(isset($field['as']) ? $field['as'] : $field['field']).'`';
    }
    
    public function loadTotal(){
        $sql = 'SELECT ';
        $sql .= $this->fields_sql[0];
        $sql .= ' FROM '.$this->from;
        if(count($this->where))
            $sql .= ' WHERE ('.implode(') AND (', $this->where).')';

        $this->total = $this->inDB->num_rows($this->inDB->query($sql, false, false));
        return $this;
    }
    
    public function load(){
        if($this->total < 1)return $this;
        if(!$this->limit && $this->page)$this->calcLimit();

        $sql = 'SELECT *,';
        $sql .= implode(', ', $this->fields_sql);
        $sql .= ' FROM '.$this->from;
        if(count($this->where))
            $sql .= ' WHERE ('.implode(') AND (', $this->where).')';
        if($this->order)
            $sql .= ' ORDER BY '.$this->order;
        if($this->limit)
            $sql .= ' LIMIT '.$this->limit;
        
        $this->result = $this->inDB->query($sql, false, false);
        return $this;
    }
    
    public function display($checkbox = true){
        $this->loadTotal()->load();
        if($this->total < 1){
            $ret['list'] = '<p class="cp_message">Нет объектов для отображения.</p>';
        }else{
        $n = "\n";
        $ret['list'] = '<div id="lt-wrap-list">
            <form name="selform" action="index.php?view='.$GLOBALS['applet'].'&do=saveorder" method="post">
            <table id="listTable" border="0" class="tablesorter" width="100%" cellpadding="0" cellspacing="0">'.$n;
        //TABLE HEADING
        $ret['list'] .= '<thead>
            <tr>'.$n;
        $by_so = explode(' ', $this->order);
        if($checkbox)
            $ret['list'] .= '<th width="20" class="lt_header" align="center"><a class="lt_header_link" href="javascript:invert();" title="Инвертировать выделение">#</a></th>'.$n;
        foreach($this->fields as $fkey => $field)
            $ret['list'] .= '<th width="'.$field['width'].'" order="'.$fkey.'" class="lt_header header'.($by_so[0] == $fkey && $by_so[1] == 'desc' ? ' headerSortUp' : '').($by_so[0] == $fkey && $by_so[1] == 'asc' ? ' headerSortDown' : '').'" onclick="lt.sort(this);">'.$field['title'].'</th>'.$n;
        if($this->actions)
            $ret['list'] .= '<th width="80" class="lt_header" align="center">Действия</th>
                </tr>
            </thead><tbody>'.$n;
        //TABLE BODY
        $r = 1;
        while($item = $this->inDB->fetch_assoc($this->result)){

            $row_class = ($r++ % 2) ? 'lt_row1' : 'lt_row2';

            $ret['list'] .= '<tr id="'.$row_class.'">'.$n;
            if($checkbox)
                $ret['list'] .= '<td class="'.$row_class.'" align="center" valign="middle"><input type="checkbox" name="item[]" value="'.$item['id'].'" /></td>'.$n;
            foreach($this->fields as $fkey => $field){
                if(isset($field['link'])){
                    $link = str_replace('%id%', $item['id'], $field['link']);
                    $data = $item[$fkey];

                    if(isset($field['maxlen']) && (mb_strlen($data) > ($field['maxlen']+3)))
                        $data = mb_substr($data, 0, $field['maxlen']).'...';

                    if($this->from != 'cms_components'){
                        $ret['list'] .= '<td class="'.$row_class.'" valign="middle">'.((isset($item['NSLevel']) && $fkey == 'title') ? str_repeat('&nbsp;&nbsp;&nbsp;&nbsp;', ($item['NSLevel'] - 1)).(($item['NSLevel'] - 1 > 0) ? ' &raquo; ' : '') : '').'<a class="lt_link" href="'.$link.'">'.$data.'</a></td>'.$n;
                    }else{
                        $ret['list'] .= '<td class="'.$row_class.'" valign="middle">
                                <a class="lt_link" style="padding:1px; padding-left:24px; background:url(/admin/images/components/'.$item['link'].'.png) no-repeat" href="'.$link.'">'.$data.'</a>
                              </td>'.$n;
                    }
                    continue;
                }
                $dos    = (isset($field['do_suffix'])) ? $field['do_suffix'] : '';
                $ids    = (isset($field['do_suffix'])) ? 'item_id' : 'id';
                if($field['field'] != 'ordering'){
                    if($field['field'] == 'published'){
                        $do     = (isset($field['do'])) ? $field['do'] : 'do';
                        $ret['list'] .= '<td class="'.$row_class.'" valign="middle">
                                <a title="'.($item['published'] ? 'Скрыть' : 'Показать').'" id="publink'.$item['id'].'" href="javascript:'.
                                "pub(".$item['id'].", '".cpAddParam(cpAddParam($_SERVER['QUERY_STRING'], $do, ($item['published'] ? 'hide' : 'show').$dos), $ids, $item['id'])."', '".cpAddParam(cpAddParam($_SERVER['QUERY_STRING'], $do, (!$item['published'] ? 'hide' : 'show').$dos), $ids, $item['id'])."', '".($item['published'] ? 'off' : 'on')."', '".(!$item['published'] ? 'off' : 'on')."');"
                                .'"><img id="pub'.$item['id'].'" src="images/actions/'.($item['published'] ? 'on' : 'off').'.gif" border="0"/></a>
                         </td>'.$n;
                        continue;
                    }

                    $data = (isset($field['prc'])) ? $field['prc']($item[$fkey]) : $item[$fkey];
                    if(isset($field['maxlen']) && (mb_strlen($data) > ($field['maxlen']+3)))
                        $data = mb_substr($data, 0, $field['maxlen']).'...';
                    $ret['list'] .= '<td class="'.$row_class.'" valign="middle">'.((isset($item['NSLevel']) && $fkey == 'title') ? str_repeat('&nbsp;&nbsp;&nbsp;&nbsp;', ($item['NSLevel'] - 1)).(($item['NSLevel'] - 1 > 0) ? ' &raquo; ' : '') : '').$data.'</td>'.$n;
                    continue;
                }
                $do = (isset($field['do'])) ? 'do=config&id='.(int) $_REQUEST['id'].'&'.$field['do'] : 'do';
                $ret['list'] .= '<td class="'.$row_class.'" valign="middle">
                        <a title="Вниз" href="?view='.$GLOBALS['applet'].'&'.$do.'=move_down&co='.$item[$fkey].'&'.$ids.'='.$item['id'].'"><img src="images/actions/down.gif" border="0"/></a>';
                if($this->from != 'cms_menu' && $this->from != 'cms_category'){
                    $ret['list'] .= '<input class="lt_input" type="text" size="4" name="ordering[]" value="'.$item['ordering'].'" />';
                    $ret['list'] .= '<input name="ids[]" type="hidden" value="'.$item['id'].'" />';
                }else{
                    $ret['list'] .= '<input class="lt_input" type="text" size="4" name="ordering[]" value="'.$item['ordering'].'" disabled/>';
                }
                $ret['list'] .= '<a title="Вверх" href="?view='.$GLOBALS['applet'].'&'.$do.'=move_up&co='.$item[$fkey].'&'.$ids.'='.$item['id'].'"><img src="images/actions/top.gif" border="0"/></a></td>'.$n;

            }//foreach fields
            if($this->actions){
                $ret['list'] .= '<td width="110" class="'.$row_class.'" align="right" valign="middle"><div style="padding-right:8px">';
                foreach($this->actions as $action){
                    if(isset($action['condition'])){
                        if(($action['condition'] == 'cpComponentHasConfig') || ($action['condition'] == 'cpModuleHasConfig')){
                            $print = $action['condition'](($action['condition'] == 'cpModuleHasConfig') ? $item['content'] : $item['link']);
                        }else{
                            $print = $action['condition']($item['id']);
                        }
                    }else{
                        $print = true;
                    }
                    if($print){
                        foreach($item as $f => $v)
                            $action['link'] = str_replace('%'.$f.'%', $v, $action['link']);
                        if(!isset($action['confirm'])){
                            $ret['list'] .= '<a href="'.$action['link'].'" title="'.$action['title'].'"><img hspace="2" src="images/actions/'.$action['icon'].'" border="0" alt="'.$action['title'].'"/></a>';
                        }else{
                            $ret['list'] .= '<a href="#" onclick="jsmsg(\''.$action['confirm'].'\', \''.$action['link'].'\')" title="'.$action['title'].'"><img hspace="2" src="images/actions/'.$action['icon'].'" border="0" alt="'.$action['title'].'"/></a>';
                        }
                    }
                }//foreach actions
                $ret['list'] .= '</div></td>'.$n;
            }//if actions
            $ret['list'] .= '</tr>'.$n;
        }//while items

        $ret['list'] .= '</tbody></table></form>
            </div>';

        $GLOBALS['cp_page_head'][] = '<script type="text/javascript" src="js/listtable.js"></script>';
        $GLOBALS['cp_page_head'][] = '<script type="text/javascript">(function($){lt.url = "index.php?view='.$GLOBALS['applet'].'"})(jQuery)</script>';
        $ret['list'] .= '<script type="text/javascript">highlightTableRows("listTable","hoverRow","clickedRow");</script>';
        $ret['list'] .= '<script type="text/javascript">activateListTable("listTable");</script>';

        $link = 'view='.$GLOBALS['applet'].'&sort='.$by_so[0].'&so='.$by_so[1];

        $ret['pb'] .= '<div id="lt-wrap-pb">'.cmsPage::getPagebar($this->total, $this->page, $this->perpage, $_SERVER['PHP_SELF'].'?'.cpAddParam($link, 'page', '%page%').'" onclick="lt.go2(%page%);return false;').'</div>';
    }
    
        if(cmsCore::inRequest('lt')){
            ob_clean();
            $ret['errors'] = false;
            cmsCore::jsonOutput($ret, true);
        }
        echo $ret['list'].$ret['pb'];
        
        return true;
        
    }
    
    
    public static function fast($table, $fields, $actions, $where = '', $orderby = '', $checkbox = true){
        
        $lt = new self;
        $orderby = explode(' ', $orderby);
        $order_by   = cmsCore::request('sort', 'str', empty($orderby[0]) ? 'title' : $orderby[0]);
        $order_so   = cmsCore::request('so', 'str', empty($orderby[1]) ? 'asc' : $orderby[1]);
        $perpage    = cmsCore::request('perpage', 'int', 0);
        $page       = cmsCore::request('page', 'int', 1);
        
        return $lt->
            setFields($fields)->
            setFrom($table)->
            setWhere($where)->
            setOrder($order_by, $order_so)->
            setPerpage($perpage)->
            setPage($page)->
            setActions($actions)->
            display($checkbox);
    }
}
