// класс для сортировки таблиц в админ панели
// © lokanaft
(function($) {
  lt = {
    url:        null,
    order:      'id',
    order_so:   'asc',
    page:       1,
    perpage:    30,
    error_msg:  'ListTable load error!',
    init: function(params){
        for(var key in params)
          if(this.hasOwnProperty(key))
            this[key] = params[key];
    },
    sort: function(th){
        if(!$(th).hasClass('headerSortDown')){
            this.order_so = 'asc';
            $(th).removeClass('headerSortUp').addClass('headerSortDown');
        }else{
            this.order_so = 'desc';
            $(th).removeClass('headerSortDown').addClass('headerSortUp');
        }
        this.order = $(th).attr('order');
        this.page = 1;
        this.load();
    },
    go2: function(page){
        this.page = page;
        this.load();
    },
    load: function(){
        if(this.url == null){this.error(1);}
        $.post(this.url, {sort: this.order, so: this.order_so, page: this.page, perpage: this.perpage, lt: 1}, function(data){
            if(data.errors == false){
                $('#lt-wrap-list').html(data.list);
                $('#lt-wrap-pb').html(data.pb);
            }else{lt.error(2);}
        }, 'json');
    },
    error: function(nmb){
        alert(this.error_msg+' ('+nmb+')');
    }
  };
})(jQuery);

$(document).ready(function(){

})